/*
 * use.c
 *
 * This source herein may be modified and/or distributed by anybody who
 * so desires, with the following restrictions:
 *    1.)  No portion of this notice shall be removed.
 *    2.)  Credit shall not be taken for the creation of this source.
 *    3.)  This code is not to be traded, sold, or used for personal
 *         gain or profit.
 *
 */
 #include "rogue.h"

static char *strange_feeling = MESG_230;

static void potion_heal(int extra);
static void idntfy(void);
static void hold_monster();
static void go_blind();
static char *get_ench_color();
static void uncurse_all();

short halluc = 0;
short blind = 0;
short confused = 0;
short levitate = 0;
short haste_self = 0;
boolean see_invisible = 0;
short extra_hp = 0;
boolean detect_monster = 0;

extern short bear_trap;
extern char hunger_str[];
extern short cur_room;
extern long level_points[];
extern boolean being_held;
extern char *fruit, *you_can_move_again;
extern boolean sustain_strength;


void quaff(void)
{
    short ch;
    char buf[80];
    object *obj;

    ch = pack_letter(MESG_231, POTION);
    if (ch == CANCEL) {
        return;
    }
    if (!(obj = get_letter_object(ch))) {
        message(MESG_232, 0);
        return;
    }

    if (obj->what_is != POTION) {
        message(MESG_233, 0);
        return;
    }

        switch(obj->which_kind) {
        case INCREASE_STRENGTH:
            message(MESG_234, 0);
            rogue.str_current++;
            if (rogue.str_current > rogue.str_max) {
                rogue.str_max = rogue.str_current;
            }
            break;
        case RESTORE_STRENGTH:
            rogue.str_current = rogue.str_max;
            message(MESG_235, 0);
            break;
        case HEALING:
            message(MESG_236, 0);
            potion_heal(0);
            break;
        case EXTRA_HEALING:
            message(MESG_237, 0);
            potion_heal(1);
            break;
        case POISON:
            if (!sustain_strength) {
                rogue.str_current -= get_rand(1, 3);
                if (rogue.str_current < 1) {
                    rogue.str_current = 1;
                }
            }
            message(MESG_238, 0);
            if (game.halluc) {
                unhallucinate();
            }
            break;
        case RAISE_LEVEL:
            rogue.exp_points = level_points[rogue.exp - 1];
            add_exp(1, 1);
            break;
        case BLINDNESS:
            go_blind();
            break;
        case HALLUCINATION:
            message(MESG_239, 0);
            game.halluc += get_rand(500, 800);
            break;
        case DETECT_MONSTER:
            show_monsters();
            if (!(level_monsters.next_monster)) {
                message(strange_feeling, 0);
            }
            break;
        case DETECT_OBJECTS:
            if (level_objects.next_object) {
                if (!game.blind) {
                    show_objects();
                }
            } else {
                message(strange_feeling, 0);
            }
            break;
        case CONFUSION:
            message((game.halluc ? MESG_240 : MESG_241), 0);
            confuse();
            break;
        case LEVITATION:
            message(MESG_242, 0);
            game.levitate += get_rand(15, 30);
            game.being_held = game.bear_trap = 0;

            break;
        case HASTE_SELF:
            message(MESG_243, 0);
            game.haste_self += get_rand(11, 21);
            if (!(game.haste_self % 2)) {
                game.haste_self++;
            }
            break;
        case SEE_INVISIBLE:
            sprintf(buf, MESG_244, fruit);
            message(buf, 0);
            if (game.blind) {
                unblind();
            }
            game.see_invisible = 1;
            relight();
            break;
        }
    print_stats(STAT_HP);
    id_potions[obj->which_kind].id_status = IDENTIFIED;
    rw_id_table(TMP_TYPE, ID_POTIONS, obj->which_kind, 1);
    vanish(obj, 1, &rogue.pack);
}

void read_scroll(void)
{
    short ch;
    object *obj;
    char msg[DCOLS];

    if(game.blind)
    {
        message(MESG_606,0);
        return;
    }

    ch = pack_letter(MESG_245, SCROLL);
    if (ch == CANCEL) {
        return;
    }

    if (!(obj = get_letter_object(ch))) {
        message(MESG_246, 0);
        return;
    }

    if (obj->what_is != SCROLL) {
        message(MESG_247, 0);
        return;
    }

    switch(obj->which_kind) {
    case SCARE_MONSTER:
        message(MESG_248, 0);
        break;
    case HOLD_MONSTER:
        hold_monster();
        break;
    case ENCH_WEAPON:
        if (rogue.weapon) {
            if (rogue.weapon->what_is == WEAPON) {
                sprintf(msg, MESG_249,name_of(rogue.weapon),
#ifndef JP
                        ((rogue.weapon->quantity <= 1) ? "s" : ""),
#endif
                        get_ench_color());

                message(msg, 0);
                if (coin_toss()) {
                    rogue.weapon->hit_enchant++;
                } else {
                    rogue.weapon->d_enchant++;
                }
            }
            rogue.weapon->is_cursed = 0;
        } else {
            message(MESG_250, 0);
        }
        break;
        case ENCH_ARMOR:
            if (rogue.armor) {
                sprintf(msg, MESG_251,get_ench_color());
             message(msg, 0);
                rogue.armor->d_enchant++;
                rogue.armor->is_cursed = 0;
                print_stats(STAT_ARMOR);
            } else {
             message(MESG_252, 0);
            }
            break;
        case IDENTIFY:
         message(MESG_253, 0);
            obj->identified = 1;
            id_scrolls[obj->which_kind].id_status = IDENTIFIED;

         rw_id_table(TMP_TYPE, ID_SCROLLS, obj->which_kind, 1); // TOTA

            idntfy();
            break;
        case TELEPORT:
            tele();
            break;
        case SLEEP:
         message(MESG_254, 0);
            take_a_nap();
            break;
        case PROTECT_ARMOR:
            if (rogue.armor) {
             message(MESG_255, 0);
                rogue.armor->is_protected = 1;
                rogue.armor->is_cursed = 0;
            } else {
             message(MESG_256, 0);
            }
            break;
        case REMOVE_CURSE:
         message((!game.halluc) ? MESG_257 : MESG_258, 0);
            uncurse_all();
            break;
        case CREATE_MONSTER:
            create_monster();
            break;
        case AGGRAVATE_MONSTER:
            aggravate();
            break;
        case MAGIC_MAPPING:
         message(MESG_259, 0);
            draw_magic_map();
            break;
        }
        id_scrolls[obj->which_kind].id_status = IDENTIFIED;
         rw_id_table(TMP_TYPE, ID_SCROLLS, obj->which_kind, 1); // TOTA
     vanish(obj, (obj->which_kind != SLEEP), &rogue.pack);
    }
        
/* vanish() does NOT handle a quiver of weapons with more than one
   arrow (or whatever) in the quiver.  It will only decrement the count.
*/
void vanish(object *obj, short rm, object *pack)
{
    if (obj->quantity > 1) {
        obj->quantity--;
    } else {
        if (obj->in_use_flags & BEING_WIELDED) {
            unwield(obj);
        } else if (obj->in_use_flags & BEING_WORN) {
            unwear(obj);
        } else if (obj->in_use_flags & ON_EITHER_HAND) {
            un_put_on(obj);
        }
        take_from_pack(obj, pack);
        free_object(obj);
    }
    if (rm) {
        (void) reg_move();
    }
}
        
static void potion_heal(int extra)
{
    long ratio;
    short add;

    rogue.hp_current += rogue.exp;

    ratio = rogue.hp_current * 100L / rogue.hp_max;
    if (ratio >= 100L) {
        rogue.hp_max += (extra ? 2 : 1);
        extra_hp += (extra ? 2 : 1);
        rogue.hp_current = rogue.hp_max;
    } else if (ratio >= 90L) {
        rogue.hp_max += (extra ? 1 : 0);
        extra_hp += (extra ? 1 : 0);
        rogue.hp_current = rogue.hp_max;
    } else {
        if (ratio < 33L) {
            ratio = 33L;
        }
        if (extra) {
            ratio += ratio;
        }
        add = (short)(ratio * (rogue.hp_max-rogue.hp_current) / 100L);
        rogue.hp_current += add;
        if (rogue.hp_current > rogue.hp_max) {
            rogue.hp_current = rogue.hp_max;
        }
    }
    if (game.blind) {
        unblind();
    }
    if (game.confused && extra) {
        unconfuse();
    } else if (game.confused) {
        game.confused = (game.confused / 2) + 1;
    }
    if (game.halluc && extra) {
        unhallucinate();
    } else if (game.halluc) {
        game.halluc = (game.halluc / 2) + 1;
    }
}
        
static void idntfy(void)
{
    short ch;
    object *obj;
    struct id *id_table;
    char desc[DCOLS];

AGAIN:
    ch = pack_letter(MESG_260, ALL_OBJECTS);
    if (ch == CANCEL) {
        return;
    }
    if (!(obj = get_letter_object(ch))) {
        message(MESG_261, 0);
//        message("", 0);
        check_message();
        goto AGAIN;
    }
    obj->identified = 1;
    if (obj->what_is & (SCROLL | POTION | WEAPON | ARMOR | WAND | RING)) {
        int type = -1;
        id_table = get_id_table(obj, &type);
        id_table[obj->which_kind].id_status = IDENTIFIED;

        if (type != -1)
            rw_id_table(TMP_TYPE, type, obj->which_kind, 1); // TOTA

    }

    get_desc(obj, desc, 1);
    message(desc, 0);
}
    
void eat(void)
{
    short ch;
    short moves;
    object *obj;
    char buf[70];

    ch = pack_letter(MESG_262, FOOD);
    if (ch == CANCEL) {
        return;
    }
    if (!(obj = get_letter_object(ch))) {
        message(MESG_263, 0);
        return;
    }

     if (obj->what_is != FOOD) {
         message(MESG_264, 0);
         return;
     }

    if ((obj->which_kind == FRUIT) || rand_percent(60)) {
        moves = get_rand(900, 1100);
        if (obj->which_kind == RATION) {
            if (get_rand(1, 10) == 1)
                message(MESG_265, 0);
            else
                message(MESG_266, 0);
        } else {
            sprintf(buf, MESG_267, fruit);
            message(buf, 0);
        }
    } else {
            moves = get_rand(700, 900);
            message(MESG_268, 0);
            add_exp(2, 1);
        }
    rogue.moves_left /= 3;
    rogue.moves_left += moves;
        hunger_str[0] = 0;
        print_stats(STAT_HUNGER);
    
    vanish(obj, 1, &rogue.pack);
}
        
static void hold_monster()
{
    short i, j;
    short mcount = 0;
    object *monster;
    short row, col;

    for (i = -2; i <= 2; i++) {
        for (j = -2; j <= 2; j++) {
            row = rogue.row + i;
            col = rogue.col + j;
            if ((row < MIN_ROW) || (row > (DROWS-2)) || (col < 0) ||
                (col > (DCOLS-1))) {
                continue;
            }
            if (dungeon[row][col] & MONSTER) {
                monster = object_at(&level_monsters, row, col);
                monster->m_flags |= ASLEEP;
                monster->m_flags &= (~WAKENS);
                mcount++;
            }
        }
    }
    if (mcount == 0) {
        message(MESG_269, 0);
    } else if (mcount == 1) {
        message(MESG_270, 0);
    } else {
        message(MESG_271, 0);
    }
}
        
void tele()
{
    mvaddch(rogue.row, rogue.col, get_dungeon_char(rogue.row, rogue.col));

    if (game.cur_room >= 0) {
        darken_room(game.cur_room);
    }
    put_player(get_room_number(rogue.row, rogue.col));
    game.being_held = 0;
    game.bear_trap = 0;

    SnapScreen(rogue.row, rogue.col);
}
    
void hallucinate()
{
    object *obj, *monster;
    short ch;
    
    if (game.blind) return;

    obj = level_objects.next_object;

    while (obj) {
        ch = mvinch(obj->row, obj->col);
        if (((ch < 'A') || (ch > 'Z')) && ((obj->row != rogue.row) || (obj->col != rogue.col)))
                if ((ch != ' ') && (ch != '.') && (ch != '#') && (ch != '+')) {
                    addch(gr_obj_char());
                }
        obj = obj->next_object;
    }
    monster = level_monsters.next_monster;

    while (monster) {
        ch = mvinch(monster->row, monster->col);
        if ((ch >= 'A') && (ch <= 'Z')) {
            addch(get_rand('A', 'Z'));
        }
        monster = monster->next_monster;
    }
}
        
void unhallucinate()
{
    game.halluc = 0;
    relight();
    message(MESG_272, 1);
}
    
void unblind()
{
    game.blind = 0;

    message(MESG_273, 1);
    relight();
    if (game.halluc) {
        hallucinate();
    }
    if (game.detect_monster) {
        show_monsters();
    }
}
    
void relight()
{
    if (game.cur_room == PASSAGE) {
        light_passage(rogue.row, rogue.col);
    } else {
        light_up_room(game.cur_room);
    }
    mvaddch(rogue.row, rogue.col, rogue.fchar);
}
    
void take_a_nap()
{
    short i;

    i = get_rand(2, 5);
//    md_sleep(1);
    while (i--) {
        mv_mons();
    }
//    md_sleep(1);
    message(you_can_move_again, 0);
}
    
static void go_blind()
{
    short i, j;

    if (!game.blind) {
        message(MESG_274, 0);
    }
    game.blind += get_rand(500, 800);

    if (game.detect_monster) {
        object *monster;

        monster = level_monsters.next_monster;

        while (monster) {
            mvaddch(monster->row, monster->col, monster->trail_char);
            monster = monster->next_monster;
        }
    }
    if (game.cur_room >= 0) {
        for (i = rooms[game.cur_room].top_row + 1;
             i < rooms[game.cur_room].bottom_row; i++) {

            for (j = rooms[game.cur_room].left_col + 1; j < rooms[game.cur_room].right_col; j++) {
                mvaddch(i, j, ' ');

            }
        }
    }
    mvaddch(rogue.row, rogue.col, rogue.fchar);
}
        
static char *get_ench_color()
{
    if (game.halluc) {
        return(id_potions[get_rand(0, POTIONS-1)].title);
    }
    return(MESG_275);
}

void confuse()
{
    game.confused += get_rand(12, 22);
}

void unconfuse()
{
    char msg[80];

    game.confused = 0;
    if (game.halluc)
        sprintf(msg, MESG_276);
    else
        sprintf(msg, MESG_277);
    message(msg, 1);
}

static void uncurse_all()
{
    object *obj;

    obj = rogue.pack.next_object;
    while (obj) {
        obj->is_cursed = 0;
        obj = obj->next_object;
    }
}
