/*---------------------------------------------------------------------
| win2fake.h
|
|	Fake out #defines for win2 2bpp routines. Allows you to conditonally
|  enable 2bpp in your app.  typical usage:
|
|	#ifdef WIN2
|	#include "win2.h"
|	#else
|	#include "win2fake.h"
|	#endif
|
|	(c) 1997-1998 ScumbySoft - wesc@ricochet.net
-----------------------------------------------------------------------*/

enum win2Color
	{
	clrWhite,
	clrLtGrey,
	clrDkGrey,
	clrBlack,
	};
	
typedef enum win2Color Win2Color;	

#define Win2SetGreyscale(creator)   0
#define Win2SetMono()               0
#define Win2SetColor(clr)           0
#define Win2SetBackgroundColor(clr) 0
#define Win2CopyMonoToGrey(fOrMode)
#define Win2PreFilterEvent(pevt)    false


//NYIWinHandle Win2CreateWindow (RectanglePtr bounds, FrameType frame, Boolean modal, Boolean focusable, WordPtr error)
//NYIWinHandle Win2CreateOffscreenWindow (SWord width, SWord height, WindowFormatType format, WordPtr error)
//NYIvoid Win2DeleteWindow (WinHandle winHandle, Boolean eraseIt)
//NYIvoid Win2InitializeWindow (WinHandle winHandle)
//NYIvoid Win2AddWindow (WinHandle winHandle)
//NYIvoid Win2RemoveWindow (WinHandle winHandle)
#define Win2SetActiveWindow(winHandle) WinSetActiveWindow(winHandle)
#define Win2SetDrawWindow(winHandle)   WinSetDrawWindow(winHandle)
#define Win2GetDrawWindow(void)        WinGetDrawWindow(void)  
#define Win2GetActiveWindow(void)      WinGetActiveWindow(void)
//NYI WinHandle Win2GetDisplayWindow (void)												  
#define Win2GetFirstWindow()                 WinGetFirstWindow() 
#define Win2EnableWindow(winHandle)          WinEnableWindow(winHandle)                       
#define Win2DisableWindow(winHandle)         WinDisableWindow(winHandle)                      
#define Win2GetWindowFrameRect(winHandle, r) WinGetWindowFrameRect(winHandle, r) 
//NYI void Win2DrawWindowFrame (void)
//NYI void Win2EraseWindow (void)
//NYI WinHandle Win2SaveBits (RectanglePtr source, WordPtr error)
//NYI void Win2RestoreBits (WinHandle winHandle, SWord destX, SWord destY)
//NYI void Win2CopyRectangle (WinHandle srcWin2, WinHandle dstWin2, 
//NYI void Win2ScrollRectangle(RectanglePtr r, enum directions direction, SWord distance, RectanglePtr vacated)
#define Win2GetDisplayExtent(extentX, extentY)  WinGetDisplayExtent(extentX, extentY) 
#define Win2GetWindowBounds(r) 					   WinGetWindowBounds(r)                  
#define Win2SetWindowBounds(winHandle, r)       WinSetWindowBounds(winHandle, r)       
#define Win2GetWindowExtent(extentX, extentY)   WinGetWindowExtent(extentX, extentY)   
#define Win2DisplayToWindowPt(extentX, extentY) WinDisplayToWindowPt(extentX, extentY) 
#define Win2WindowToDisplayPt(extentX, extentY) WinWindowToDisplayPt(extentX, extentY) 
#define Win2GetClip(r)       WinGetClip(r) 
#define Win2SetClip(r)       WinSetClip(r) 
#define Win2ResetClip()      WinResetClip() 
#define Win2ClipRectangle(r) WinClipRectangle()
#define Win2Modal(winHandle) WinModal(winHandle)

#define Win2DrawLine(x1, y1, x2, y2) WinDrawLine(x1, y1, x2, y2)
//NYI void Win2DrawGrayLine (SWord x1, SWord y1, SWord x2, SWord y2)
//NYI void Win2EraseLine (SWord x1, SWord y1, SWord x2, SWord y2)
//NYI void Win2InvertLine (SWord x1, SWord y1, SWord x2, SWord y2)
//NYI void Win2FillLine (SWord x1, SWord y1, SWord x2, SWord y2)
//NYI void Win2DrawRectangle (RectanglePtr r, Word cornerDiam);
#define Win2EraseRectangle (r, cornerDiam) WinEraseRectangle(r, cornerDiam)
//NYI void Win2InvertRectangle (RectanglePtr r, Word cornerDiam)
#define Win2FillRectangle (r, cornerDiam) WinFillRectangle(r, cornerDiam)
//NYI void Win2DrawRectangleFrame (FrameType frame, RectanglePtr r)
//NYI void Win2DrawGrayRectangleFrame (FrameType frame, RectanglePtr r)
//NYI void Win2EraseRectangleFrame (FrameType frame, RectanglePtr r)
//NYI void Win2InvertRectangleFrame (FrameType frame, RectanglePtr r)
#define Win2GetFramesRectangle(frame, r, obscuredRect) WinGetFramesRectangle(frame, r, obscuredRect) 
#define Win2DrawChars(chars, len, x, y) WinDrawChars(chars, len, x, y) 
//NYI void Win2DrawInvertedChars (CharPtr chars, Word len, SWord x, SWord y)
//NYI void Win2EraseChars (CharPtr chars, Word len, SWord x, SWord y)
//NYI void Win2InvertChars (CharPtr chars, Word len, SWord x, SWord y)
#define Win2SetUnderlineMode(mode) WinSetUnderlineMode(mode) 

// Patterns NYI in Win2
#define Win2GetPattern(pat) WinGetPattern(pat)
#define Win2SetPattern(pat) WinGetPattern(pat)
#define Win2DrawBitmap(bitmapP, x, y) WinDrawBitmap(bitmapP, x, y) 



						

